=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Hugo Lefeuvre <hle@debian.org>
Build-Depends: debhelper-compat (= 12), dh-python | dh-sequence-python3
Build-Depends-Indep: dh-python,
                     gettext,
                     itstool,
                     intltool,
                     python3-all,
                     python3-docutils
Standards-Version: 4.4.1
Homepage: https://kupferlauncher.github.io/
Vcs-Git: https://salsa.debian.org/python-team/packages/kupfer.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/kupfer

Package: kupfer
Architecture: all
Depends: gir1.2-gtk-3.0,
         gir1.2-keybinder-3.0,
         python3-dbus,
         python3-gi-cairo,
         python3-xdg,
         ${misc:Depends},
         ${python3:Depends}
Recommends: gir1.2-wnck-3.0 (>= 3.20),
            yelp
Suggests: gir1.2-ayatanaappindicator3-0.1,
          python3-setproctitle
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 .
 Kupfer is written in Python 3 and has a flexible architecture based on plugins
 to extend its features.
