=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/kupfer-$1\.tar\.gz/ \
  https://github.com/kupferlauncher/kupfer/tags .*/v?(\d\S+)\.tar\.gz
