## kupfer 324

=== debian/changelog ===
kupfer (324-1) unstable; urgency=medium

  * New upstream release.
  * debian/changelog: Use upstream versioning scheme, use 324
    instead of 0+v324.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Jan 2024 08:55:15 -0500

kupfer (0+v323-1) unstable; urgency=medium

  * New upstream release. (Closes: #994742)
  * debian/control:
    + Bump Standards-Version to 4.6.2.
    + Bump debhelper compat to v13.
    + No longer use Build-Depends-Indep field, not useful.
    + Add new build-dependency python3-pygments for missing
      doc build feature.
    + Add myself into uploaders list.
    + Drop Hugo Lefeuvre from uploaders due to retirement.
      (Closes: #1050281)
  * debian/copyright: Slight updates.
  * debian/patches/0002-ayanata-appindicator.patch: Refresh patch
    on using Ayanata AppIndicator.
  * debian/patches/0003-Fix-waf-shebang.patch: Fix waf shebang.

 -- Boyuan Yang <byang@debian.org>  Wed, 06 Dec 2023 14:25:23 -0500

kupfer (0+v320-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + kupfer: Drop versioned constraint on gir1.2-wnck-3.0 in Recommends.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 28 May 2022 01:17:20 +0100

kupfer (0+v320-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Update standards version to 4.5.0, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 21 Aug 2021 13:38:17 +0100
