## kupfer 326

=== debian/changelog ===
kupfer (326-2) unstable; urgency=medium

  * QA upload.
  * Orphan the package.

 -- Boyuan Yang <byang@debian.org>  Sun, 03 Mar 2024 11:30:35 -0500

kupfer (326-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 26 Feb 2024 19:20:05 -0500

kupfer (325-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 21 Jan 2024 10:30:37 -0500
