=== debian/changelog ===
kupfer (327-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 12 May 2024 09:20:11 -0400
