=== debian/changelog ===
kupfer (327+git20240901-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot.
    + Include fix for command execution. (Closes: #1082576)

 -- Boyuan Yang <byang@debian.org>  Sat, 26 Oct 2024 18:08:45 -0400
