=== po/wscript ===
def build(bld):
    bld(features="intltool_po", appname=bld.env["PACKAGE"])
