=== debian/changelog ===
kupfer (328-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * debian/control: Raise dependency of gir1.2-ayatanaappindicator3-0.1
    from suggests to depends due to upstream changes.
  * debian/patches/0002-ayanata-appindicator.patch: Dropped, fixed upstream.

 -- Boyuan Yang <byang@debian.org>  Fri, 25 Apr 2025 12:27:00 -0400
