=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  python3-all,
  python3-docutils,
  python3-pygments,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://kupferlauncher.github.io/
 Vcs-Git: https://salsa.debian.org/python-team/packages/kupfer.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/kupfer
@@ -19,6 +19,7 @@
 Package: kupfer
 Architecture: all
 Depends:
+ gir1.2-ayatanaappindicator3-0.1,
  gir1.2-gtk-3.0,
  gir1.2-keybinder-3.0,
  python3-dbus,
@@ -30,7 +31,6 @@
  gir1.2-wnck-3.0,
  yelp,
 Suggests:
- gir1.2-ayatanaappindicator3-0.1,
  python3-setproctitle,
 Description: fast and lightweight desktop summoner/launcher
  Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
