=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/kupfer-$1\.tar\.gz/" \
  https://github.com/kupferlauncher/kupfer/tags .*/v?(\d\S+)\.tar\.gz
