## kupfer 329

=== debian/changelog ===
kupfer (329-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Dec 2025 20:01:55 -0500
